#include "hardware.h"
#include <signal.h>

void delay(unsigned int d) { int i; for (i = 0; i<d; i++) { nop(); nop(); } }

int test=0;

int main(void) {
    int sec=0,min=0,hr=0;

    WDTCTL = WDTCTL_INIT;           //Init watchdog timer
    P1OUT  = P1OUT_INIT;            //Init output data of port1
    P1SEL  = P1SEL_INIT;            //Select port or module -function on port1
    P1DIR  = P1DIR_INIT;                //Init port direction register of port1
    P1IES  = P1IES_INIT;                //init port interrupts
    P1IE   = P1IE_INIT;
/*
 while (1) {   
            P1OUT ^= 0xff; delay(0x4fff);
            P1OUT ^= 0xff; delay(0x4fff);
 }
*/
    TACTL  = TASSEL0+TACLR;
    //CCTL0  |= CCIE; // 0x10
    asm("BIS #0x10,&0x0162");
    CCR0   = 0x7FFF;
    //TACTL  |= MC0;  // 0x10
    asm("BIS     #0x10,&0x0160");
    eint();
    
    while (1) 
    {// asm("bis     #208,   r2\n");
	    
     sec++;
     if (sec>59) {min++;sec=0;}
     if (min>59) {hr++;min=0;}
     if (hr>23) hr=0;
     P1OUT = 0xff; 
     do {asm("nop");} while ((TACTL&0x01)==0x00);
     P1OUT = 0x00; delay(0x4fff);
     test=0;
    }
    
}

 interrupt(TIMERA0_VECTOR) isr() {test=1;}
