#include "hardware.h" 
#include <stdio.h> 

#define consigne 4000
#define P      60 
#define I       20
#define addre   0x300

unsigned short pid(unsigned short vc,unsigned short pos,unsigned short DAC)
// les variables C vont sur la pile R15=vc,R14=pos,R13=DAC...
{		
    signed short vp;
    signed short interval;
    signed short erreur;
    signed short somme;
   
    vp=*(unsigned short *)(0x2F8); // old val compteur
    *(unsigned short *)(0x2F8)=vc;

    erreur=vc-vp-consigne;
    
    somme=*(unsigned short*)(addre);	// tableau de l'integrale
    somme-=*(unsigned short *)(pos);	
    *(unsigned short*)(pos)=erreur;
    somme+=erreur;
    *(unsigned short*)(addre)=somme;
    
    DAC-=erreur/P;
    DAC-=((somme)/(14*I));		// 14 elements dans tableau

    if (DAC > 0x8000) DAC = 0x00;	// DAC<0
    if (DAC > 1400) DAC = 1400;
    
    return(DAC);
}

